//memo02.cpp
#define ID_EDIT 100
#define ID_EDIT2 101
#include <windows.h>
#include <windowsx.h>
#include "resource.h"

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK MyEditProc(HWND, UINT, WPARAM, LPARAM);

ATOM InitApp(HINSTANCE);
BOOL InitInstance(HINSTANCE, int);
int MyNew(HWND);
int MyOpen(HWND);
int MySave(HWND);
int MySaveAs(HWND);
int MyConfirm(HWND);
int MyYmd(HWND, HWND, int);
int MySetInfo(HWND hEdit, HWND hEdit2);

char szClassName[] = "memo02";	//EBhENX
HINSTANCE hInst; //CX^Xnh
char szTitle[128] = "Lł킩郁ǂ";
char *szTitle_org = "Lł킩郁ǂ[%s](%doCg)";
char szFile[MAX_PATH];
char szFileTitle[MAX_PATH];
HWND hMain;//CEBhẼnh
HWND hSubEdit;
BOOL bInfo = TRUE;// EBhE̕\E\
WNDPROC OrgEditProc;

int WINAPI WinMain(HINSTANCE hCurInst, HINSTANCE hPrevInst,
				   LPSTR lpsCmdLine, int nCmdShow)
{
	MSG msg;
	BOOL bRet;
	HACCEL hAccel;
	
	hInst = hCurInst;
	if (!InitApp(hCurInst))
		return FALSE;
	if (!InitInstance(hCurInst, nCmdShow)) 
		return FALSE;

	hAccel = LoadAccelerators(hCurInst, "MYACCEL");

	while ((bRet = GetMessage(&msg, NULL, 0, 0)) != 0) {
		if (bRet == -1) {
			break;
		} else {
			if (!TranslateAccelerator(hMain, hAccel, &msg)) {
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}
	}
	return (int)msg.wParam;
}

//EBhEENX̓o^

ATOM InitApp(HINSTANCE hInst)
{
	WNDCLASSEX wc;
	wc.cbSize = sizeof(WNDCLASSEX);
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = WndProc;	//vV[W
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInst;//CX^X
	wc.hIcon = (HICON)LoadImage(hInst,
		"MYICON",
		IMAGE_ICON,
		0,
		0,
		LR_DEFAULTSIZE | LR_SHARED);
	wc.hCursor = (HCURSOR)LoadImage(NULL,
		MAKEINTRESOURCE(IDC_ARROW),
		IMAGE_CURSOR,
		0,
		0,
		LR_DEFAULTSIZE | LR_SHARED);
	wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName = "MYMENU";	//j[
	wc.lpszClassName = (LPCSTR)szClassName;
	wc.hIconSm = (HICON)LoadImage(hInst,
		"MYICON",
		IMAGE_ICON,
		0,
		0,
		LR_DEFAULTSIZE | LR_SHARED);

	return (RegisterClassEx(&wc));
}

//EBhE̐

BOOL InitInstance(HINSTANCE hInst, int nCmdShow)
{
	HWND hWnd;

	hWnd = CreateWindow(szClassName,
			szTitle, //^Cgo[ɂ̖O\܂
			WS_OVERLAPPEDWINDOW, //EBhE̎
			CW_USEDEFAULT,	//wW
			CW_USEDEFAULT,	//xW
			CW_USEDEFAULT,	//
			CW_USEDEFAULT,	//
			NULL, //eEBhẼnhAeƂNULL
			NULL, //j[nhANXj[gƂNULL
			hInst, //CX^Xnh
			NULL);
	if (!hWnd)
		return FALSE;
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	hMain = hWnd;
	return TRUE;
}

//EBhEvV[W

LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
	int id, w, h, info_h, nStart, nEnd;
	static HWND hEdit, hEdit2;
	static HMENU hMenu;
	HICON hIcon;
	HDC hdc, hdc_mem;
	PAINTSTRUCT ps;
	HBITMAP hBmp;
	BITMAP bmp_info;
	RECT rc;
	MENUITEMINFO mi;

	switch (msg) {
		case WM_CREATE:
			hMenu = GetMenu(hWnd);
			hEdit = CreateWindow(
				"EDIT",
				NULL,
				WS_CHILD | WS_VISIBLE | 
				ES_WANTRETURN | ES_MULTILINE | ES_AUTOVSCROLL | WS_VSCROLL |
				ES_AUTOHSCROLL | WS_HSCROLL, 
				0, 0,
				0, 0,
				hWnd,
				(HMENU)ID_EDIT,
				hInst,
				NULL);
			hEdit2 = CreateWindow(
				"EDIT",
				NULL,
				WS_CHILD | WS_VISIBLE | 
				ES_WANTRETURN | ES_MULTILINE | ES_AUTOVSCROLL |	ES_AUTOHSCROLL, 
				0, 0,
				0, 0,
				hWnd,
				(HMENU)ID_EDIT2,
				hInst,
				NULL);
			hSubEdit = hEdit2;
			strcat(szTitle, "[]");
			SetWindowText(hWnd, szTitle);
			Edit_LimitText(hEdit, 0);
			SendMessage(hEdit2, 
				EM_SETMARGINS, 
				EC_LEFTMARGIN | EC_RIGHTMARGIN, 
				MAKELPARAM(20, 20));
			OrgEditProc = (WNDPROC)SetWindowLong(hEdit, 
				GWL_WNDPROC, 
				(LONG)MyEditProc);
			break;
		case WM_SIZE:
			if (bInfo)
				info_h = 50;
			else
				info_h = 0;
			MoveWindow(hEdit, 0, 0, LOWORD(lp), HIWORD(lp) - info_h, TRUE);
			if (bInfo) {
				MoveWindow(hEdit2, 
					150, HIWORD(lp) - 50, 
					LOWORD(lp) - 150, 
					50, 
					TRUE);
			}
			break;
		case WM_PAINT:
			if (bInfo) {
				GetClientRect(hWnd, &rc);
				hdc = BeginPaint(hWnd, &ps);
				hBmp = (HBITMAP)LoadImage(hInst, 
					"MYBMP", 
					IMAGE_BITMAP, 
					0, 0, 
					LR_DEFAULTCOLOR);
				GetObject(hBmp, (int)sizeof(BITMAP), &bmp_info);
				w = bmp_info.bmWidth;
				h = bmp_info.bmHeight;
				hdc_mem = CreateCompatibleDC(hdc);
				SelectObject(hdc_mem, hBmp);
				BitBlt(hdc, 0, rc.bottom - 50, w, h, hdc_mem, 0, 0, SRCCOPY);
				DeleteObject(hBmp);
				DeleteDC(hdc_mem);
				EndPaint(hWnd, &ps);
			}
			break;
		case WM_COMMAND:
			switch (LOWORD(wp)) {
				case IDM_NEW:
					MyNew(hEdit);
					break;
				case IDM_OPEN:
					MyOpen(hEdit);
					break;
				case IDM_END:
					SendMessage(hWnd, WM_CLOSE, 0, 0);
					break;
				case IDM_SAVE:
					MySave(hEdit);
					break;
				case IDM_SAVEAS:
					MySaveAs(hEdit);
					break;
				case IDM_UNDO:
					SendMessage(hEdit, EM_UNDO, 0, 0);
					break;
				case IDM_CUT:
					SendMessage(hEdit, WM_CUT, 0, 0);
					break;
				case IDM_COPY:
					SendMessage(hEdit, WM_COPY, 0, 0);
					break;
				case IDM_PASTE:
					SendMessage(hEdit, WM_PASTE, 0, 0);
					break;
				case IDM_DEL:
					SendMessage(hEdit, WM_CLEAR, 0, 0);
					break;
				case IDM_ALL:
					SendMessage(hEdit, EM_SETSEL, 0, -1);
					break;
				case IDM_ABOUT:
					hIcon = (HICON)LoadImage(hInst,
								"MYICON",
								IMAGE_ICON,
								0,
								0,
								LR_DEFAULTSIZE | LR_SHARED);
					ShellAbout(hWnd, 
						"Lł킩郁ǂ#"
						"Lł킩郁ǂVer.0.500", 
						"Copyright(C) 2002 Y.Kumei", hIcon);
					break;
				case IDM_INFO:
					GetWindowRect(hWnd, &rc);
					if (bInfo) {
						bInfo = FALSE;
						ShowWindow(hEdit2, SW_HIDE);
					} else {
						bInfo = TRUE;
						ShowWindow(hEdit2, SW_NORMAL);
					}
					GetClientRect(hWnd, &rc);
					SendMessage(hWnd, WM_SIZE, 
						(WPARAM)SIZE_RESTORED, 
						MAKELPARAM(rc.right, rc.bottom));
					UpdateWindow(hEdit);
					break;
				case IDM_YMD1:
					MyYmd(hEdit, hEdit2, 1);
					break;
				case IDM_YMD2:
					MyYmd(hEdit, hEdit2, 2);
					break;
				case IDM_HMS1:
					MyYmd(hEdit, hEdit2, 3);
					break;
				case IDM_HMS2:
					MyYmd(hEdit, hEdit2, 4);
					break;
			}
			if (lp != (LPARAM)hEdit)
				return DefWindowProc(hWnd, msg, wp, lp);
			switch (HIWORD(wp)) {
				case EN_CHANGE:
					MySetInfo(hEdit, hEdit2);
					break;
			}
			break;
		case WM_SETFOCUS:
			SetFocus(hEdit);
			break;
		case WM_INITMENU:
			if (SendMessage(hEdit, EM_CANUNDO, 0, 0) == 0) {
				EnableMenuItem(hMenu, IDM_UNDO, MF_BYCOMMAND | MF_GRAYED);
			} else {
				EnableMenuItem(hMenu, IDM_UNDO, MF_BYCOMMAND | MF_ENABLED);
			}
			mi.cbSize = sizeof(MENUITEMINFO);
			mi.fMask = MIIM_STATE;
			if (bInfo) {
				mi.fState = MFS_CHECKED;
				SetMenuItemInfo(hMenu, IDM_INFO, FALSE, &mi);
			} else {
				mi.fState = MFS_UNCHECKED;
				SetMenuItemInfo(hMenu, IDM_INFO, FALSE, &mi);
			}
			SendMessage(hEdit, EM_GETSEL, (WPARAM)&nStart, (LPARAM)&nEnd);
			if (nStart == nEnd) {
				EnableMenuItem(hMenu, IDM_CUT, MF_BYCOMMAND | MF_GRAYED);
				EnableMenuItem(hMenu, IDM_COPY, MF_BYCOMMAND | MF_GRAYED);
			} else {
				EnableMenuItem(hMenu, IDM_CUT, MF_BYCOMMAND | MF_ENABLED);
				EnableMenuItem(hMenu, IDM_COPY, MF_BYCOMMAND | MF_ENABLED);
			}
			if (IsClipboardFormatAvailable(CF_TEXT)) {
				EnableMenuItem(hMenu, IDM_PASTE, MF_BYCOMMAND | MF_ENABLED);
			} else {
				EnableMenuItem(hMenu, IDM_PASTE, MF_BYCOMMAND | MF_GRAYED);
			}
			DrawMenuBar(hWnd);
			break;
		case WM_CLOSE:
			id = MyConfirm(hEdit);
			if (id == IDCANCEL)
				break;
			id = MessageBox(hWnd,
				"IĂ낵ł",
				"mF",
				MB_YESNO | MB_ICONQUESTION);
			if (id == IDYES) {
				SetWindowLong(hEdit, GWL_WNDPROC, (LONG)OrgEditProc);
				DestroyWindow(hEdit);
				DestroyWindow(hEdit2);
				DestroyWindow(hWnd);
			}
			break;
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		default:
			return (DefWindowProc(hWnd, msg, wp, lp));
	}
	return 0;
}

int MyNew(HWND hEdit)
{
	int id;
	id = MyConfirm(hEdit);
	if (id == IDCANCEL) {
		return -1;
	}
	Edit_SetText(hEdit, "");
	SetWindowText(GetParent(hEdit), "Lł킩郁ǂ[]");
	strcpy(szFile, "");
	return 0;
}

int MyOpen(HWND hEdit)
{
	int id;
	HWND hMain;
    DWORD dwSize = 0L;
    OPENFILENAME ofn;
    HANDLE hFile;
    DWORD dwAccBytes;
    char  *lpszBuf;
	
	HGLOBAL hMem;

    id = MyConfirm(hEdit);
	if (id == IDCANCEL)
		return -1;

    memset(&ofn, 0, sizeof(OPENFILENAME));
    ofn.lStructSize = sizeof(OPENFILENAME);
    ofn.hwndOwner = hEdit;
    ofn.lpstrFilter = "text(*.txt)\0*.txt\0All files(*.*)\0*.*\0\0";
    ofn.lpstrFile = szFile;
    ofn.lpstrFileTitle = szFileTitle;
    ofn.nMaxFile = MAX_PATH;
    ofn.nMaxFileTitle = MAX_PATH;
    ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
    ofn.lpstrDefExt = "txt";
    ofn.lpstrTitle = "Lł킩t@CI[v";

    if(GetOpenFileName(&ofn) == 0)
        return -1;
    hFile = CreateFile(szFile, //t@C
		GENERIC_READ, //ǂ݂Ƃ/݃ANZX
		0, //Lݒ 0ƋLΏۂƂȂ
		NULL, //ZLeB 
		OPEN_ALWAYS, //t@Cłɑ݂Ă邩ǂ̍l
		FILE_ATTRIBUTE_NORMAL, //t@C
		NULL);
    dwSize = GetFileSize(hFile, NULL);

	hMem = GlobalAlloc(GHND, sizeof(char) * dwSize + 1);
	if (hMem == NULL) {
		MessageBox(hEdit, 
			"mۂł܂", 
			"Lł킩郁ǂ",
			MB_ICONEXCLAMATION | MB_OK);
		return -1;
	}
	lpszBuf = (char *)GlobalLock(hMem);
    
    ReadFile(hFile, lpszBuf, dwSize, &dwAccBytes, NULL);
    lpszBuf[dwAccBytes] = '\0';
    Edit_SetText(hEdit, lpszBuf);
    wsprintf(szTitle, szTitle_org, szFileTitle, dwSize);
	hMain = GetParent(hEdit);
    SetWindowText(hMain, szTitle);
    CloseHandle(hFile);
	GlobalUnlock(hMem);
	GlobalFree(hMem);

	return 0;
}

int MySaveAs(HWND hEdit)
{
	OPENFILENAME ofn;
    HANDLE hFile;
    DWORD dwAccBytes;
    
	char *lpszBuf;
    int nLen;
	HGLOBAL hMem;
    
    nLen = GetWindowTextLength(hEdit);
	hMem = GlobalAlloc(GHND, sizeof(char) * nLen + 1);
	lpszBuf = (char *)GlobalLock(hMem);

    GetWindowText(hEdit, lpszBuf, nLen + 1);
    
    memset(&ofn, 0, sizeof(OPENFILENAME));
    ofn.lStructSize = sizeof(OPENFILENAME);
    ofn.hwndOwner = hEdit;
    ofn.lpstrFilter = "text(*.txt)\0*.txt\0All files(*.*)\0*.*\0\0";
    ofn.lpstrFile = szFile;
    ofn.lpstrFileTitle = szFileTitle;
    ofn.nFilterIndex = 1;
    ofn.nMaxFile = MAX_PATH;
    ofn.nMaxFileTitle = MAX_PATH;
    ofn.Flags = OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY;
    ofn.lpstrDefExt = "txt";
    ofn.lpstrTitle = "Otĕۑ";

    if(GetSaveFileName(&ofn) == 0)
        return -1;
    hFile = CreateFile(szFile, 
		GENERIC_WRITE, 
		0, 
		NULL, 
		CREATE_ALWAYS, //ɐVt@C쐬
		FILE_ATTRIBUTE_NORMAL, 
		NULL);
	if (hFile == INVALID_HANDLE_VALUE) {
		MessageBox(hEdit, 
			"t@C̃I[vɎs܂", 
			"Error", 
			MB_OK | MB_ICONEXCLAMATION);
		return -1;
	}
    WriteFile(hFile, 
		lpszBuf, 
		(DWORD)strlen(lpszBuf), 
		&dwAccBytes, 
		NULL);
    wsprintf(szTitle, szTitle_org, szFileTitle, nLen);
    SetWindowText(GetParent(hEdit), szTitle);
    if(CloseHandle(hFile) == 0)
        MessageBox(hEdit, "Error CloseHandle", "Error", MB_OK);
    SendMessage(hEdit, EM_SETMODIFY, FALSE, 0);
	GlobalUnlock(hMem);
	GlobalFree(hMem);

	return 0;
}

int MySave(HWND hEdit)
{
	HANDLE hFile;
    DWORD dwAccBytes;
    int nLen;
	char *lpszBuf;
	HGLOBAL hMem;

	if (strcmp(szFile, "") == 0) {
		MessageBox(hEdit, 
			"t@CtĂ܂",
			"Lł킩郁ǂ",
			MB_OK);
		MySaveAs(hEdit);
		return -1;
	}
    nLen = GetWindowTextLength(hEdit);
	hMem = GlobalAlloc(GHND, sizeof(char) * nLen + 1);
	lpszBuf = (char *)GlobalLock(hMem);


    GetWindowText(hEdit, lpszBuf, nLen + 1);

    hFile = CreateFile(szFile, 
		GENERIC_WRITE, 
		0, 
		NULL, 
		TRUNCATE_EXISTING,
		FILE_ATTRIBUTE_NORMAL, 
		NULL);
    WriteFile(hFile, 
		lpszBuf, 
		(DWORD)strlen(lpszBuf), 
		&dwAccBytes, 
		NULL);

	GlobalUnlock(hMem);
	GlobalFree(hMem);
    SendMessage(hEdit, EM_SETMODIFY, FALSE, 0);
	wsprintf(szTitle, szTitle_org, szFileTitle, nLen);
    SetWindowText(GetParent(hEdit), szTitle);
    if (CloseHandle(hFile) == 0) {
        MessageBox(hEdit, "Error CloseHandle", "Error", MB_OK);
        return -1;
    }

    return 0;
}

int MyConfirm(HWND hEdit)
{
	int id;

	if (SendMessage(hEdit, EM_GETMODIFY, 0, 0) == TRUE) {
		id = MessageBox(hEdit,
			"XVĂ܂B\nύXۑ܂?",
			"Lł킩郁ǂ",
			MB_YESNOCANCEL | MB_ICONEXCLAMATION);
		if (id == IDYES) {
			MySave(hEdit);
		} else if (id == IDCANCEL) {
			return IDCANCEL;
		} else if (id ==  IDNO) {
			return IDNO;
		}
	}
	return 0;
}

int MyYmd(HWND hEdit, HWND hEdit2, int nOption)
{
	SYSTEMTIME st;
	char szBuf[64];

	GetLocalTime(&st);
	switch (nOption) {
		case 1:
			wsprintf(szBuf, "%dN%02d%02d", st.wYear, st.wMonth, st.wDay);
			break;
		case 2:
			wsprintf(szBuf, "%d/%02d/%02d", st.wYear, st.wMonth, st.wDay);
			break;
		case 3:
			wsprintf(szBuf, "%02d%02d%02db", st.wHour, st.wMinute, st.wSecond);
			break;
		case 4:
			wsprintf(szBuf, "%02d:%02d:%02d", st.wHour, st.wMinute, st.wSecond);
			break;
	}

	SetWindowText(hEdit2, szBuf);

	SendMessage(hEdit2, EM_SETSEL, 0, -1);
	SendMessage(hEdit2, WM_COPY, 0, 0);
	SendMessage(hEdit, WM_PASTE, 0, 0);

	return 0;
}

int MySetInfo(HWND hEdit, HWND hEdit2)
{
	char szBuf[256], szBuf2[64];
	int nLen, nLine, nStart, nEnd;

	nLen = GetWindowTextLength(hEdit);
	nLine = (int)SendMessage(hEdit, EM_GETLINECOUNT, 0, 0);
	wsprintf(szBuf, 
		"̓oCg= %d oCg\t"
		"s = %d ", nLen, nLine);
	SendMessage(hEdit, EM_GETSEL, (WPARAM)&nStart, (LPARAM)&nEnd);
	if (nStart != nEnd) {
		wsprintf(szBuf2, "\r\nIJnʒu = %d, Iʒu = %d", nStart, nEnd);
		strcat(szBuf, szBuf2);
	}
	SetWindowText(hEdit2, szBuf);
	return 0;
}

LRESULT CALLBACK MyEditProc(HWND hEdit, UINT msg, WPARAM wp, LPARAM lp)
{
	switch (msg) {
		case WM_LBUTTONUP:
		case WM_KEYUP:
			MySetInfo(hEdit, hSubEdit);
			
			break;

	}
	return CallWindowProc(OrgEditProc, hEdit, msg, wp, lp);
}

